// Copyright (c) 1997 New York University
// file timer.i
// "@(#) $Id: timer.i,v 1.3 1997/05/21 04:14:01 baratloo Exp $"

#ifndef _TIMER_I
#define _TIMER_I

#include <ostream.h>
#include <time.h>
#include <unistd.h>

class Timer {
private:
  int	        num;
  int           started;
  timeval	    startTime;
  double 	    totalTime;

public:
  Timer() {
    reset	();
  }

  inline void reset() {
    num       = 0;
    started   = 0;
    totalTime = 0;
  }
  
  inline void start() {
	if (started)
	  return;     // improper use. -ab.
    started   = 1;
	gettimeofday(&startTime, 0);
    num++;
  }

  inline void stop() {
    if (!started)
      return;     // improper use. -ab.

    timeval		stopTime;
	gettimeofday(&stopTime, 0);
    started    = 0;
    totalTime += (stopTime.tv_sec+stopTime.tv_usec*1e-6) - (startTime.tv_sec+startTime.tv_usec*1e-6);
  }

  inline double time() {
	return totalTime;
  }

  inline int numStarts() {
	return num;
  }

  friend ostream &operator<<(ostream &os, Timer &t) {
    os << t.totalTime << " (sec.) in " << t.num << " calls";
    return os;
  }
};

#endif

